<template>
  <v-row class="mt-2">
    <v-col>
      <v-card>
        <v-card-title>
          <!-- filter by spacific coloum -->
          <v-text-field
            v-model="search"
            append-icon="mdi-magnify"
            label="Search"
            single-line
            hide-details
          ></v-text-field>
        </v-card-title>
        <v-data-table
          :headers="headers"
          :items="filteredList"
          :items-per-page="5"
          class="elevation-1"
        >
          <template v-slot:item.name="{ item }">
            <div class="ma-1">
              <v-avatar>
                <img
                  src="https://cdn.vuetifyjs.com/images/john.jpg"
                  alt="John"
                /> </v-avatar
              ><span class="text-bold-xl px-1">{{ item.name }}</span>
            </div>
          </template>

          <template v-slot:item.action="{ item }">
            <v-btn icon @click="goToEdit(item.id)" color="primary"
              ><v-icon>mdi-pencil</v-icon></v-btn
            >
            <v-btn icon @click="submitDelete(item.id)" color="#e21717"
              ><v-icon>mdi-delete</v-icon></v-btn
            >
          </template>
        </v-data-table>
        <v-fab-transition fluid style="z-index: 100">
          <v-btn fab fixed color="#008ef8" @click="goToAdd()" bottom right>
            <span class="text-white-sm">
              <v-icon>mdi-plus</v-icon>
            </span>
          </v-btn>
        </v-fab-transition>
      </v-card>
    </v-col>
  </v-row>
</template>

<script>
import { createNamespacedHelpers } from "vuex";
const data = createNamespacedHelpers("data");

export default {
  name: "TableViewDashboard",
  data() {
    return {
      search: "",
      headers: [
        { text: "Name", value: "name" },
        { text: "Email", value: "email" },
        { text: "Amount", value: "amount" },
        { text: "", value: "action" }
      ]
    };
  },
  mounted() {
    this.$store.dispatch("data/getData");
  },
  computed: {
    filteredList() {
      if (this.search != null) {
        return this.resMasterData.filter(item => {
          return item.name.toLowerCase().includes(this.search.toLowerCase());
        });
      } else {
        return this.resMasterData;
      }
    },
    ...data.mapState(["resMasterData"])
  },
  methods: {
    goToEdit(val) {
      this.$router.push("/master-data/edit/" + val);
    },
    goToAdd() {
      this.$router.push("/master-data/add");
    },
    submitDelete(val) {
      this.$store.commit("data/SET_IDDATA", val);
      this.$swal
        .fire({
          title: "Delete Data",
          text: "Kamu yakin menghapus data ini?",
          icon: "warning",
          showDenyButton: true,
          confirmButtonColor: "#3085d6",
          cancelButtonColor: "#d33",
          confirmButtonText: "Yes, delete it!"
        })
        .then(result => {
          if (result.isConfirmed) {
            this.$store
              .dispatch("data/deteleData")
              .then(response => {
                const res = response.data;
                const messagesSuccess = res.status.message;
                if (res.status) {
                  this.$swal
                    .fire("Success!!", messagesSuccess, "success")
                    .then(result => {
                      if (result.isConfirmed) {
                        this.$store.dispatch("data/getData");
                      }
                    });
                }
              })
              .catch(error => {
                const messagesError = error.response.data.status.message;
                this.$swal.fire("Error!!", messagesError, "error");
              });
          }
        });
    }
  }
};
</script>
